﻿using System.Collections.Generic;
using Microsoft.Xna.Framework.Content;

namespace AnimationClassLibrary
{
    // 动画数据类，包含一组动画片段。
    public class AnimationData
    {
        /// <summary>
        /// 动画片段的集合，其中键为动画名称，值为动画片段类AnimationClip
        /// </summary>
        [ContentSerializer(CollectionItemName = "AnimationDictionary")]
        public Dictionary<string, AnimationClip> AnimationClips { get; private set; }

        /// <summary>
        /// 动画数据类，包含一组动画片段
        /// </summary>
        public AnimationData(Dictionary<string, AnimationClip> animationClips)
        {
            AnimationClips = animationClips ;
        }

        // 用于串行化的私有构造函数
        private AnimationData() { }
    }
}
