using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using AnimationClassLibrary;

namespace AnimationClassLibrary
{
    /// <summary>
    /// ModelAnimationDataͶݵĻࡣ
    /// ԹƬΣٶȡ
    /// </summary>
    public abstract class ModelAnimationPlayerBase
    {        
        float playbackRate = 1.0f;                     // ٶ
        bool paused;                                   // Ƿͣ״̬
        bool loop;                                     // Ƿѭ
        TimeSpan startTime;                            // ſʼʱ̺ͽʱ
        int endKeyframeIndex,startKeyframeIndex;       // ʼŶӦĹؼ֡

        /// <summary>
        /// ǰŵĶƬ
        /// </summary>
        public ModelAnimationClip CurrentClip { get; private set; }

        /// <summary>
        /// ǷѾ
        /// </summary>
        public bool Done { get; private set; }

        /// <summary>
        /// ǰŵĹؼ֡
        /// </summary>
        public int CurrentKeyframeIndex{ get;private set;}

        /// <summary>
        /// ǰѾŵʱ
        /// </summary>
        public TimeSpan ElapsedTime { get; private set; } 

        /// <summary>
        /// ¶
        /// </summary>
        public void Update(GameTime gameTime)
        {
            if (CurrentClip == null || Done)
                return;
            if (paused)
                return;

            TimeSpan time = gameTime.ElapsedGameTime;
            // ٶ
            if (playbackRate != 1.0f)
                time = TimeSpan.FromMilliseconds(time.TotalMilliseconds * playbackRate);
            ElapsedTime += time;

            // ǰŵĹؼ֡ѳָĽؼ֡.
            while (CurrentKeyframeIndex  >= endKeyframeIndex )
            {
                // ѭ򽫵ǰؼ֡˵ʼؼ֡
                if (loop)
                {
                    CurrentKeyframeIndex = startKeyframeIndex;
                    ElapsedTime = TimeSpan.Zero;
                    InitClip();
                }
                else
                {
                    Done = true;
                    break;
                }
            }

            // ȡؼ֡
            IList<ModelKeyframe> keyframes = CurrentClip.Keyframes;
            // ȡӶͷĲʱ
            TimeSpan totalTime = ElapsedTime + startTime;

            while (CurrentKeyframeIndex < endKeyframeIndex)
            {
                ModelKeyframe keyframe = keyframes[CurrentKeyframeIndex];

                // ѾĹؼ֡ѭ
                if (keyframe.Time > totalTime )
                    break;

                // õǰĹؼ֡
                SetKeyframe(keyframe);
                // һ֡
                CurrentKeyframeIndex++;
            }

            OnUpdate();
        }

        /// <summary>
        /// ٶѭĶƬΡ
        /// </summary>        
        /// <param name="clip">ҪŵĶƬ</param>
        public void StartClip(ModelAnimationClip clip)
        {
            StartClip(clip, true,1.0f);
        }

        /// <summary>
        /// ĶƬ
        /// </summary>
        /// <param name="clip">ҪŵĶƬ</param>
        /// <param name="loop">Ƿѭ</param>
        /// <param name="playbackRate">ű</param>
        public void StartClip(ModelAnimationClip clip, bool loop,float playbackRate)
        {
            StartClip (clip,loop,playbackRate,0,clip .Keyframes .Count -1);
        }

        /// <summary>
        /// ݸĹؼ֡ؼ֮֡ĶƬ
        /// </summary>
        /// <param name="clip">ҪŵĶƬ</param>        
        /// <param name="loop">Ƿѭ</param>
        /// <param name="playbackRate">ű</param>
        /// <param name="startIndex">ʼʱ̵Ĺؼ֡</param>
        /// <param name="endIndex">ʱ̵Ĺؼ֡</param>
        public void StartClip(ModelAnimationClip clip,
            bool loop, float playbackRate, int startIndex, int endIndex)
        {
            this.CurrentClip = clip;
            this.loop = loop;
            this.playbackRate = playbackRate;
            this.startKeyframeIndex = CurrentKeyframeIndex = startIndex;
            this.endKeyframeIndex = endIndex;            
            this.startTime = clip.Keyframes[startIndex].Time ;
            
            ElapsedTime = TimeSpan.Zero;                
            paused = false;
            Done = false;            

            // ĳʼƬεķ
            InitClip();
        }

        /// <summary>
        /// ͣŶ
        /// </summary>
        public void PauseClip()
        {
            paused = true;
        }

        /// <summary>
        /// Ŷ
        /// </summary>
        public void ResumeClip()
        {
            paused = false;
        }

        /// <summary>
        /// ԶƬνгʼԱ̳д
        /// </summary>
        protected virtual void InitClip()
        {
        }

        /// <summary>
        /// ùؼ֡ݣԱ̳д
        /// </summary>
        protected virtual void SetKeyframe(ModelKeyframe keyframe)
        {
        }

        /// <summary>
        /// ⷽԱ̳дUpdate()е
        /// </summary>
        protected virtual void OnUpdate()
        {
        }

        
    }
}
