using System.Xml;
using AnimationClassLibrary;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content.Pipeline.Serialization.Intermediate;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System.Collections.Generic;
using System;

namespace XNAAnimation8
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        SpriteFont font;
        string message = "Hit 1,2,3Play Animation.";
        
        QuakeCamera fpsCam;         //         
        Model model;                // ģ
        Matrix[] modelTransforms;
        Matrix[] originalModelTransforms;
        
        Grid grid;                 // лһΪοϵ

        // 洢ǰǰһ֡ļ״̬
        KeyboardState currentKeyboardState;
        KeyboardState lastKeyboardState;

        //AnimationData animationData;
        ModelAnimationData modelAnimationData;
        ModelAnimationBlender blender;
        
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        protected override void Initialize()
        {
            spriteBatch = new SpriteBatch(graphics.GraphicsDevice);
            font = Content.Load<SpriteFont>("SpriteFont1");
            fpsCam = new QuakeCamera(GraphicsDevice.Viewport, new Vector3(0, 12, 15), 0, -0.6f);
            
            // ´ɶļʱãһɣЩûˡ
            // жƬʵתͷ
            /*List<Keyframe> keyframes1 = new List<Keyframe>();
            keyframes1.Add(new Keyframe(2, TimeSpan.Zero , Vector3.Zero, Quaternion.CreateFromYawPitchRoll(0, 0, 0), Vector3.One));
            keyframes1.Add(new Keyframe(2, TimeSpan.FromSeconds(1), Vector3.Zero,
                Quaternion.CreateFromYawPitchRoll(MathHelper.ToRadians(45), 0, 0), Vector3.One));
            keyframes1.Add(new Keyframe(2, TimeSpan.FromSeconds(2), Vector3.Zero,
                Quaternion.CreateFromYawPitchRoll(MathHelper.ToRadians(90), 0, 0), Vector3.One));
            AnimationClip animation1 = new AnimationClip(keyframes1);

            // жƬʵתñӶ
            List<Keyframe> keyframes2 = new List<Keyframe>();
            keyframes2.Add(new Keyframe(4, TimeSpan.Zero, Vector3.Zero, Quaternion.CreateFromYawPitchRoll(0, 0, 0), Vector3.One));
            keyframes2.Add(new Keyframe(4, TimeSpan.FromSeconds(1), Vector3.Zero, Quaternion.CreateFromYawPitchRoll(MathHelper.ToRadians(45), 0, 0), Vector3.One));
            keyframes2.Add(new Keyframe(4, TimeSpan.FromSeconds(2), Vector3.Zero, Quaternion.CreateFromYawPitchRoll(MathHelper.ToRadians(90), 0, 0), Vector3.One));
            AnimationClip animation2 = new AnimationClip(keyframes2);

            // жƬʵֱת嶯
            List<Keyframe> keyframes3 = new List<Keyframe>();
            keyframes3.Add(new Keyframe(0, TimeSpan.Zero , Vector3.Zero, Quaternion.Identity , Vector3.One));
            keyframes3.Add(new Keyframe(0, TimeSpan.FromSeconds(2), Vector3.Zero, Quaternion.CreateFromYawPitchRoll(MathHelper.ToRadians(90), 0, 0), Vector3.One));
            AnimationClip animation3 = new AnimationClip(keyframes3);

            // жƬʵƶ
            List<Keyframe> keyframes4 = new List<Keyframe>();
            keyframes4.Add(new Keyframe(0, TimeSpan.Zero, Vector3.Zero, Quaternion.Identity , Vector3.One));
            keyframes4.Add(new Keyframe(0, TimeSpan.FromSeconds(2), new Vector3(8, 0, 0), Quaternion.Identity, Vector3.One));
            AnimationClip animation4 = new AnimationClip(keyframes4);

            Dictionary<string, AnimationClip> animationClips = new Dictionary<string,AnimationClip>();
            animationClips.Add("TurnHead", animation1);
            animationClips.Add("TurnHat", animation2);
            animationClips.Add("BodyRotationY", animation3);
            animationClips.Add("BodyMoveX", animation4);

            animationData = new AnimationData(animationClips);*/

            base.Initialize();
        }

        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // 
            grid = new Grid();
            grid.GridColor = Color.LimeGreen;
            grid.GridScale = 1.0f;
            grid.GridSize = 32;
            grid.LoadContent(graphics.GraphicsDevice);
            grid.ProjectionMatrix = fpsCam.ProjectionMatrix;
            grid.WorldMatrix = Matrix.Identity;

            // ģ
            model = Content.Load<Model>("HierarchicalMan2");
            modelTransforms = new Matrix[model.Bones.Count];
            originalModelTransforms= new Matrix[model.Bones.Count];
            model.CopyBoneTransformsTo(originalModelTransforms);
            //AnimationHelper.AddModelTransform(animationData, originalModelTransforms);            
            
            // ض
            modelAnimationData = Content.Load<ModelAnimationData>("AnimationData");
            // ʼ
            blender = new ModelAnimationBlender(modelAnimationData, ref model);            
        }        

        protected override void Update(GameTime gameTime)
        {
            GamePadState gamePadState = GamePad.GetState(PlayerIndex.One);
            MouseState mouseState = Mouse.GetState();

            // ȡǰļ״̬һ֡ļ״̬
            lastKeyboardState = currentKeyboardState;
            currentKeyboardState = Keyboard.GetState();

            if (gamePadState.Buttons.Back == ButtonState.Pressed || currentKeyboardState.IsKeyDown(Keys.Escape))
                this.Exit();

            fpsCam.Update(mouseState, currentKeyboardState, gamePadState);
            grid.ViewMatrix = fpsCam.ViewMatrix;            

            // һǸڵ㡢һڵ㶯
            if (IsNewKeyPress(Keys.D1))
            {
                blender.Blend("TurnHat", false, 1.0f);
                //blender.Blend("BodyRotationY", false, 1.0f);
                blender.Blend("BodyMoveX", false, 1.0f);
            }
            // Ǹڵ㶯
            if (IsNewKeyPress(Keys.D2))
            {
                blender.Blend("TurnHat",false ,1.0f);
                blender.Blend("TurnHead", false, 1.0f);
            }
            // ڵ㶯ᷢͻ
            if (IsNewKeyPress(Keys.D3))
            {
                blender.Blend("BodyRotationY", true, 1.0f);
                blender.Blend("BodyMoveX", false, 1.0f);
            }
            // ּ4ݴлΪһxmlļ
            /*if (IsNewKeyPress(Keys.D4))
            {
                // ýxmlԪĶ
                XmlWriterSettings settings = new XmlWriterSettings();
                settings.Indent = true;

                using (XmlWriter writer = XmlWriter.Create(@"E:/AnimationData.Animation", settings))
                {
                    IntermediateSerializer.Serialize(writer, animationData, null);
                }
            }*/

            blender.Update(gameTime);
            base.Update(gameTime);
        }

        // жϼ̵¼ĸ
        bool IsNewKeyPress(Keys key)
        {
            return currentKeyboardState.IsKeyDown(key) && lastKeyboardState.IsKeyUp(key);
        }

        protected override void Draw(GameTime gameTime)
        {
            // 2Dıͼ豸ĳЩȾ״̬ڻ3DǰҪĻ
            GraphicsDevice.DepthStencilState = DepthStencilState.Default;
            GraphicsDevice.BlendState = BlendState.Opaque;
            
            GraphicsDevice.Clear(Color.Black);

            // 
            grid.Draw();            
            //ģ
            model.CopyAbsoluteBoneTransformsTo(modelTransforms);
            
            foreach (ModelMesh mesh in model.Meshes)
            {
                foreach (BasicEffect effect in mesh.Effects)
                {
                    effect.EnableDefaultLighting();
                    effect.World = modelTransforms[mesh.ParentBone.Index];
                    effect.View = fpsCam.ViewMatrix;
                    effect.Projection = fpsCam.ProjectionMatrix;
                }
                mesh.Draw();
            }

            // ʾϢ
            spriteBatch.Begin();
            spriteBatch.DrawString(font, message, new Vector2(5, 5), Color.Red);
            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
